// Copyright (c) 2000-2001 Quadralay Corporation.  All rights reserved.
//

function  WWHJavaScriptSettings_Object()
{
  this.mHoverText = new WWHJavaScriptSettings_HoverText_Object();

  this.mTabs   = new WWHJavaScriptSettings_Tabs_Object();
  this.mTOC    = new WWHJavaScriptSettings_TOC_Object();
  this.mIndex  = new WWHJavaScriptSettings_Index_Object();
  this.mSearch = new WWHJavaScriptSettings_Search_Object();
}

function  WWHJavaScriptSettings_HoverText_Object()
{
  this.mbEnabled = true;

  this.mFontStyle = "font-family: Verdana, Arial, Helvetica, sans-serif ; font-size: 9px";

  this.mWidth = 200;

  this.mForegroundColor = "#000000";
  this.mBackgroundColor = "#FFFFFF";
  this.mBorderColor     = "#7A1600";
}

function  WWHJavaScriptSettings_Tabs_Object()
{
  this.mFontStyle = "font-family:Verdana, Arial, Helvetica, sans-serif; font-size:11px;";

  this.mSelectedTabColor       = "#F1F1F2";
  this.mSelectedTabBorderColor = "#BF83B9";
  this.mSelectedTabTextColor   = "#807F83";

  this.mDefaultTabColor       = "#FAFAFB";
  this.mDefaultTabBorderColor = "#7962AA";
  this.mDefaultTabTextColor   = "#807F83";
}

function  WWHJavaScriptSettings_TOC_Object()
{
  this.mbShow = true;

  this.mFontStyle = "font-family:Verdana, Arial, Helvetica, sans-serif; font-size:9px";

  this.mEnabledColor  = "#1A1A1A";
  this.mDisabledColor = "#1A1A1A";

  this.mIndent = 14;
}

function  WWHJavaScriptSettings_Index_Object()
{
  this.mbShow = false;

  this.mFontStyle = "font-family: Verdana, Arial, Helvetica, sans-serif ; font-size: 10pt";

  this.mEnabledColor  = "#B22317";
  this.mDisabledColor = "B22317";

  this.mIndent = 14;

  this.mNavigationFontStyle     = "font-family: Verdana, Arial, Helvetica, sans-serif ; font-size: 8pt ; font-weight: bold";
  this.mNavigationCurrentColor  = "#EE3224";
  this.mNavigationEnabledColor  = "#7A1600";
  this.mNavigationDisabledColor = "#BABCBE";
}

function  WWHJavaScriptSettings_Index_DisplayOptions(ParamIndexOptions)
{
  ParamIndexOptions.fSetThreshold(10);

  ParamIndexOptions.fSetSeperator(" - ");

  ParamIndexOptions.fGroup("Numerics", false, true, "1234567890");
  ParamIndexOptions.fGroup("", true, true, "ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  ParamIndexOptions.fGroup("Symbols", false, true, "!@#$%^&*(){}[]<>\"|\\.,;-?+");
}

function  WWHJavaScriptSettings_Search_Object()
{
  this.mbShow = true;

  this.mFontStyle = "font-family: Verdana, Arial, Helvetica, sans-serif ; font-size: 9px; color:#1A1A1A";

  this.mEnabledColor  = "#1A1A1A";
  this.mDisabledColor = "#1A1A1A";

  this.mIndent = 14;

  this.mbShowBook = true;
  this.mbShowRank = true;
}
